--
-- Dirty Tire Tracks for FS19
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0.0.0 - 2020-08-31 - first release
--
source(Utils.getFilename("dirtyTireTracks.lua", g_currentModDirectory))

DirtyTireTracks_register = {}

function DirtyTireTracks_register:loadMap()
end
function DirtyTireTracks_register:register(name)
	if g_specializationManager:getSpecializationByName("DirtyTireTracks") == nil then
	  if DirtyTireTracks == nil then 
		print("ERROR: unable to add specialization 'DirtyTireTracks'")
	  else 
		for i, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
			if typeDef ~= nil and i ~= "locomotive" and i ~= "trainTrailer" and i ~= "trainTimberTrailer" then 
				local isWheels = false
				local isDrivable = false
				local isRoller = false
				for name, spec in pairs(typeDef.specializationsByName) do
					if name == "wheels"  then
						isWheels = true
					end
					if name == "drivable"  then
						isDrivable = true
					end
					if name == "roller"  then
						isRoller = true
					end
				end 
				if isWheels and not isRoller then
					typeDef.specializationsByName["DirtyTireTracks"] = DirtyTireTracks
					table.insert(typeDef.specializationNames, "DirtyTireTracks")
					table.insert(typeDef.specializations, DirtyTireTracks)  
				end 
			end 
		end   
	  end 
	end
end
VehicleTypeManager.finalizeVehicleTypes = Utils.prependedFunction(VehicleTypeManager.finalizeVehicleTypes, DirtyTireTracks_register.register)
print("----DirtyTireTracks registered.")

addModEventListener(DirtyTireTracks_register);